Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.Designer.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.Designer.cs	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.Designer.cs	(revision 13718)
@@ -587,5 +668,5 @@
       this.problemInstancesTabPage.Name = "problemInstancesTabPage";
       this.problemInstancesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.problemInstancesTabPage.Size = new System.Drawing.Size(681, 428);
+      this.problemInstancesTabPage.Size = new System.Drawing.Size(681, 477);
       this.problemInstancesTabPage.TabIndex = 6;
       this.problemInstancesTabPage.Text = "Problem Instances";
@@ -622,5 +703,5 @@
       this.problemInstancesTabControl.Name = "problemInstancesTabControl";
       this.problemInstancesTabControl.SelectedIndex = 0;
-      this.problemInstancesTabControl.Size = new System.Drawing.Size(675, 390);
+      this.problemInstancesTabControl.Size = new System.Drawing.Size(675, 439);
       this.problemInstancesTabControl.TabIndex = 4;
       // 
@@ -631,5 +712,5 @@
       this.instancesTabPage.Name = "instancesTabPage";
       this.instancesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.instancesTabPage.Size = new System.Drawing.Size(667, 364);
+      this.instancesTabPage.Size = new System.Drawing.Size(667, 413);
       this.instancesTabPage.TabIndex = 0;
       this.instancesTabPage.Text = "Instances";
@@ -645,5 +726,5 @@
       this.problemInstancesView.Name = "problemInstancesView";
       this.problemInstancesView.ReadOnly = false;
-      this.problemInstancesView.Size = new System.Drawing.Size(661, 358);
+      this.problemInstancesView.Size = new System.Drawing.Size(661, 407);
       this.problemInstancesView.TabIndex = 0;
       this.problemInstancesView.ViewsLabelVisible = true;
@@ -656,5 +737,5 @@
       this.mapTabPage.Name = "mapTabPage";
       this.mapTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.mapTabPage.Size = new System.Drawing.Size(667, 364);
+      this.mapTabPage.Size = new System.Drawing.Size(667, 413);
       this.mapTabPage.TabIndex = 1;
       this.mapTabPage.Text = "Map";
@@ -676,19 +757,19 @@
       this.instanceMapChart.Location = new System.Drawing.Point(3, 3);
       this.instanceMapChart.Name = "instanceMapChart";
-      series2.ChartArea = "Default";
-      series2.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Point;
-      series2.Legend = "Legend";
-      series2.MarkerSize = 10;
-      series2.Name = "InstancesSeries";
       series3.ChartArea = "Default";
       series3.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Point;
       series3.Legend = "Legend";
-      series3.MarkerColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
-      series3.MarkerSize = 15;
-      series3.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Cross;
-      series3.Name = "CurrentInstanceSeries";
-      this.instanceMapChart.Series.Add(series2);
+      series3.MarkerSize = 10;
+      series3.Name = "InstancesSeries";
+      series4.ChartArea = "Default";
+      series4.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Point;
+      series4.Legend = "Legend";
+      series4.MarkerColor = System.Drawing.Color.FromArgb(((int)(((byte)(192)))), ((int)(((byte)(0)))), ((int)(((byte)(0)))));
+      series4.MarkerSize = 15;
+      series4.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Cross;
+      series4.Name = "CurrentInstanceSeries";
       this.instanceMapChart.Series.Add(series3);
-      this.instanceMapChart.Size = new System.Drawing.Size(661, 358);
+      this.instanceMapChart.Series.Add(series4);
+      this.instanceMapChart.Size = new System.Drawing.Size(661, 407);
       this.instanceMapChart.TabIndex = 0;
       // 
@@ -708,7 +789,7 @@
             | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.progressPanel.Location = new System.Drawing.Point(0, 81);
+      this.progressPanel.Location = new System.Drawing.Point(0, 32);
       this.progressPanel.Name = "progressPanel";
-      this.progressPanel.Size = new System.Drawing.Size(692, 454);
+      this.progressPanel.Size = new System.Drawing.Size(692, 503);
       this.progressPanel.TabIndex = 2;
       this.progressPanel.Visible = false;
@@ -718,7 +799,7 @@
       this.okbDownloadButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.okbDownloadButton.Location = new System.Drawing.Point(6, 52);
+      this.okbDownloadButton.Location = new System.Drawing.Point(3, 3);
       this.okbDownloadButton.Name = "okbDownloadButton";
-      this.okbDownloadButton.Size = new System.Drawing.Size(661, 23);
+      this.okbDownloadButton.Size = new System.Drawing.Size(686, 23);
       this.okbDownloadButton.TabIndex = 1;
       this.okbDownloadButton.Text = "Download from OKB";
@@ -733,17 +814,4 @@
       this.openFileDialog.Title = "Open Optimizer";
       // 
-      // solutionsSeedingTableLayoutPanel
-      // 
-      this.solutionsSeedingTableLayoutPanel.ColumnCount = 1;
-      this.solutionsSeedingTableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.solutionsSeedingTableLayoutPanel.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.solutionsSeedingTableLayoutPanel.Location = new System.Drawing.Point(3, 3);
-      this.solutionsSeedingTableLayoutPanel.Name = "solutionsSeedingTableLayoutPanel";
-      this.solutionsSeedingTableLayoutPanel.RowCount = 2;
-      this.solutionsSeedingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 30F));
-      this.solutionsSeedingTableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.solutionsSeedingTableLayoutPanel.Size = new System.Drawing.Size(661, 360);
-      this.solutionsSeedingTableLayoutPanel.TabIndex = 0;
-      // 
       // ExpertSystemView
       // 
@@ -751,18 +819,7 @@
       this.Controls.Add(this.okbDownloadButton);
       this.Controls.Add(this.tabControl);
-      this.Controls.Add(this.evaluationsLimitabel);
-      this.Controls.Add(this.maxEvaluationsTextBox);
       this.Controls.Add(this.progressPanel);
       this.Name = "ExpertSystemView";
       this.Size = new System.Drawing.Size(692, 535);
-      this.Controls.SetChildIndex(this.progressPanel, 0);
-      this.Controls.SetChildIndex(this.maxEvaluationsTextBox, 0);
-      this.Controls.SetChildIndex(this.evaluationsLimitabel, 0);
-      this.Controls.SetChildIndex(this.tabControl, 0);
-      this.Controls.SetChildIndex(this.nameLabel, 0);
-      this.Controls.SetChildIndex(this.okbDownloadButton, 0);
-      this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.infoLabel, 0);
-      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.tabControl.ResumeLayout(false);
       this.problemTabPage.ResumeLayout(false);
@@ -770,17 +827,17 @@
       this.solutionsTabPage.PerformLayout();
       this.solutionsTabControl.ResumeLayout(false);
-      this.solutionsSeedingTabPage.ResumeLayout(false);
       this.solutionsQualityTabPage.ResumeLayout(false);
+      this.solutionsLengthScaleTabPage.ResumeLayout(false);
       this.solutionsDiversityTabPage.ResumeLayout(false);
       this.solutionsFdcTabPage.ResumeLayout(false);
-      this.solutionsLengthScaleTabPage.ResumeLayout(false);
+      this.solutionsFdcTabPage.PerformLayout();
       this.solutionsNetworkTabPage.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.solutionsNetworkChart)).EndInit();
       this.solversTabPage.ResumeLayout(false);
       this.solversTabPage.PerformLayout();
-      this.solversSplitContainer.Panel1.ResumeLayout(false);
-      this.solversSplitContainer.Panel2.ResumeLayout(false);
-      ((System.ComponentModel.ISupportInitialize)(this.solversSplitContainer)).EndInit();
-      this.solversSplitContainer.ResumeLayout(false);
+      this.solverTabControl.ResumeLayout(false);
+      this.resultsTabPage.ResumeLayout(false);
+      this.parametersTabPage.ResumeLayout(false);
+      this.operatorGraphTabPage.ResumeLayout(false);
       this.runsTabPage.ResumeLayout(false);
       this.okbTabPage.ResumeLayout(false);
@@ -792,5 +849,4 @@
       ((System.ComponentModel.ISupportInitialize)(this.instanceMapChart)).EndInit();
       this.ResumeLayout(false);
-      this.PerformLayout();
 
     }
@@ -838,11 +894,17 @@
     private Visualization.ChartControlsExtensions.EnhancedChart solutionsNetworkChart;
     private System.Windows.Forms.Button algorithmCloneButton;
-    private System.Windows.Forms.SplitContainer solversSplitContainer;
-    private Core.Views.ParameterCollectionView solverParametersView;
-    private Optimization.Views.ResultCollectionView solverResultsView;
     private System.Windows.Forms.Label solutionNameLabel;
     private System.Windows.Forms.ComboBox solutionNameComboBox;
-    private System.Windows.Forms.TabPage solutionsSeedingTabPage;
-    private System.Windows.Forms.TableLayoutPanel solutionsSeedingTableLayoutPanel;
+    private MainForm.WindowsForms.DragOverTabControl solverTabControl;
+    private System.Windows.Forms.TabPage resultsTabPage;
+    private Optimization.Views.ResultCollectionView solverResultsView;
+    private System.Windows.Forms.TabPage solutionSeedingTabPage;
+    private System.Windows.Forms.TabPage parametersTabPage;
+    private Core.Views.ParameterCollectionView solverParametersView;
+    private System.Windows.Forms.Panel seedingStrategyPanel;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.TabPage operatorGraphTabPage;
+    private MainForm.WindowsForms.ViewHost operatorGraphViewHost;
+    private System.Windows.Forms.CheckBox fdcBetweenBestCheckBox;
   }
 }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.cs	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/ExpertSystemView.cs	(revision 13718)
@@ -40,10 +40,9 @@
 using System.Windows.Forms;
 using System.Windows.Forms.DataVisualization.Charting;
-using DoubleValue = HeuristicLab.Data.DoubleValue;
 
 namespace HeuristicLab.OptimizationExpertSystem {
-  [View("Expert-system Optimizer View")]
+  [View("Knowledge Center (all-in-one view)")]
   [Content(typeof(ExpertSystem), IsDefaultView = true)]
-  public partial class ExpertSystemView : NamedItemView {
+  public partial class ExpertSystemView : ItemView {
     private EnumValueView<SeedingStrategyTypes> seedingStrategyView;
     private CheckedItemListView<IScope> seedingSolutionsView;
@@ -72,8 +71,6 @@
         Dock = DockStyle.Fill
       };
-      solutionsSeedingTableLayoutPanel.SuspendLayout();
-      solutionsSeedingTableLayoutPanel.Controls.Add(seedingStrategyView, 0, 0);
-      solutionsSeedingTableLayoutPanel.Controls.Add(seedingSolutionsView, 0, 1);
-      solutionsSeedingTableLayoutPanel.ResumeLayout(true);
+      seedingStrategyPanel.Controls.Add(seedingStrategyView);
+      solutionSeedingTabPage.Controls.Add(seedingSolutionsView);
     }
 
@@ -86,4 +83,9 @@
       Content.SuggestedInstances.ItemsRemoved -= SuggestedInstancesOnChanged;
       Content.SuggestedInstances.ItemsReplaced -= SuggestedInstancesOnChanged;
+      Content.SolutionSeedingPool.CollectionReset -= SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsAdded -= SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsRemoved -= SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsReplaced -= SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.CheckedItemsChanged -= SeedingPoolOnChanged;
       DeregisterProblemEvents(Content.Problem);
       base.DeregisterContentEvents();
@@ -98,4 +100,9 @@
       Content.SuggestedInstances.ItemsRemoved += SuggestedInstancesOnChanged;
       Content.SuggestedInstances.ItemsReplaced += SuggestedInstancesOnChanged;
+      Content.SolutionSeedingPool.CollectionReset += SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsAdded += SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsRemoved += SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.ItemsReplaced += SeedingPoolOnChanged;
+      Content.SolutionSeedingPool.CheckedItemsChanged += SeedingPoolOnChanged;
       RegisterProblemEvents(Content.Problem);
     }
@@ -201,4 +208,8 @@
     }
 
+    private void SeedingPoolOnChanged(object sender, EventArgs e) {
+      UpdateSolutionVisualization();
+    }
+
     private void SolutionsOnChanged(object sender, EventArgs e) {
       UpdateNamesComboboxes();
@@ -217,9 +228,9 @@
       if (!int.TryParse(maxEvaluationsTextBox.Text, out value)) {
         e.Cancel = !maxEvaluationsTextBox.ReadOnly && maxEvaluationsTextBox.Enabled;
-        errorProvider.SetError(maxEvaluationsTextBox, "Please enter a valid integer number.");
+        //errorProvider.SetError(maxEvaluationsTextBox, "Please enter a valid integer number.");
       } else {
         Content.MaximumEvaluations = value;
         e.Cancel = false;
-        errorProvider.SetError(maxEvaluationsTextBox, null);
+        //errorProvider.SetError(maxEvaluationsTextBox, null);
       }
     }
@@ -299,6 +310,13 @@
       if (InvokeRequired) { Invoke((Action<object, EventArgs>)SuggestedInstancesComboBoxOnSelectedIndexChanged, sender, e); return; }
       if (suggestedInstancesComboBox.SelectedIndex >= 0) {
-        solverParametersView.Content = Content.SuggestedInstances[suggestedInstancesComboBox.SelectedIndex].Parameters;
-      } else solverParametersView.Content = null;
+        var alg = Content.SuggestedInstances[suggestedInstancesComboBox.SelectedIndex];
+        solverParametersView.Content = alg.Parameters;
+        var engineAlg = alg as EngineAlgorithm;
+        if (engineAlg != null) operatorGraphViewHost.Content = engineAlg.OperatorGraph;
+        else operatorGraphViewHost.Content = new Data.StringValue("Algorithm is not modeled as an operator graph.");
+      } else {
+        solverParametersView.Content = null;
+        operatorGraphViewHost.Content = null;
+      }
       SetEnabledStateOfControls();
     }
@@ -312,7 +330,22 @@
       }
       UpdateSolutionDiversityAnalysis(calculator);
-      UpdateSolutionFdcAnalysis(calculator);
+      UpdateSolutionFdcAnalysis(calculator, fdcBetweenBestCheckBox.Checked);
       UpdateSolutionLengthScaleAnalysis(calculator);
       UpdateSolutionNetworkAnalysis(calculator);
+    }
+
+    private void FdcBetweenBestCheckBoxOnCheckedChanged(object sender, EventArgs e) {
+      if (InvokeRequired) { Invoke((Action<object, EventArgs>)FdcBetweenBestCheckBoxOnCheckedChanged, sender, e); return; }
+      UpdateSolutionFdcAnalysis((ISolutionSimilarityCalculator)similarityComboBox.SelectedItem, fdcBetweenBestCheckBox.Checked);
+    }
+
+    private void SolutionsNetworkChartOnMouseClick(object sender, MouseEventArgs e) {
+      var result = solutionsNetworkChart.HitTest(e.X, e.Y);
+      if (result.ChartElementType == ChartElementType.DataPoint) {
+        var point = (DataPoint)result.Object;
+        var solutionScope = point.Tag as IScope;
+        if (solutionScope == null || !Content.SolutionSeedingPool.Contains(solutionScope)) return;
+        Content.SolutionSeedingPool.SetItemCheckedState(solutionScope, !Content.SolutionSeedingPool.ItemChecked(solutionScope));
+      }
     }
     #endregion
@@ -386,5 +419,5 @@
         var calculator = (ISolutionSimilarityCalculator)similarityComboBox.SelectedItem;
         UpdateSolutionDiversityAnalysis(calculator);
-        UpdateSolutionFdcAnalysis(calculator);
+        UpdateSolutionFdcAnalysis(calculator, fdcBetweenBestCheckBox.Checked);
         UpdateSolutionLengthScaleAnalysis(calculator);
         UpdateSolutionNetworkAnalysis(calculator);
@@ -403,5 +436,5 @@
         solutionsQualityViewHost.Content = dt;
       }
-      QualityDistributionAnalyzer.UpdateTable(dt, Content.Problem.Solutions.Select(x => x.Solution).OfType<IScope>().Where(x => x.Variables.ContainsKey(qualityName)).Select(x => x.Variables[qualityName].Value).OfType<DoubleValue>().Select(x => x.Value));
+      QualityDistributionAnalyzer.UpdateTable(dt, GetSolutionScopes().Select(x => GetQuality(x, qualityName) ?? double.NaN).Where(x => !double.IsNaN(x)));
     }
 
@@ -409,8 +442,9 @@
       try {
         solutionsDiversityViewHost.Content = null;
-        var similarities = new double[Content.Problem.Solutions.Count, Content.Problem.Solutions.Count];
-        for (int i = 0; i < Content.Problem.Solutions.Count; i++) {
-          for (int j = 0; j < Content.Problem.Solutions.Count; j++)
-            similarities[i, j] = calculator.CalculateSolutionSimilarity((IScope)Content.Problem.Solutions[i].Solution, (IScope)Content.Problem.Solutions[j].Solution);
+        var solutionScopes = GetSolutionScopes();
+        var similarities = new double[solutionScopes.Count, solutionScopes.Count];
+        for (var i = 0; i < solutionScopes.Count; i++) {
+          for (var j = 0; j < solutionScopes.Count; j++)
+            similarities[i, j] = calculator.CalculateSolutionSimilarity(solutionScopes[i], solutionScopes[j]);
         }
         var hm = new HeatMap(similarities, "Solution Similarities", 0.0, 1.0);
@@ -419,14 +453,28 @@
     }
 
-    private void UpdateSolutionFdcAnalysis(ISolutionSimilarityCalculator calculator) {
+    private void UpdateSolutionFdcAnalysis(ISolutionSimilarityCalculator calculator, bool distanceToBest) {
       try {
         solutionsFdcViewHost.Content = null;
+        var solutionScopes = GetSolutionScopes();
         var points = new List<Point2D<double>>();
-        for (int i = 0; i < Content.Problem.Solutions.Count; i++) {
-          for (int j = 0; j < Content.Problem.Solutions.Count; j++) {
-            if (i == j) continue;
-            var qDiff = Math.Abs(((DoubleValue)((IScope)Content.Problem.Solutions[i].Solution).Variables[calculator.QualityVariableName].Value).Value
-              - ((DoubleValue)((IScope)Content.Problem.Solutions[j].Solution).Variables[calculator.QualityVariableName].Value).Value);
-            points.Add(new Point2D<double>(qDiff, 1.0 - calculator.CalculateSolutionSimilarity((IScope)Content.Problem.Solutions[i].Solution, (IScope)Content.Problem.Solutions[j].Solution)));
+        if (distanceToBest) {
+          var maximization = ((IValueParameter<Data.BoolValue>)Content.Problem.MaximizationParameter).Value.Value;
+          var bestSolutions = (maximization ? solutionScopes.MaxItems(x => GetQuality(x, calculator.QualityVariableName) ?? double.NegativeInfinity)
+                                            : solutionScopes.MinItems(x => GetQuality(x, calculator.QualityVariableName) ?? double.PositiveInfinity)).ToList();
+          foreach (var solScope in solutionScopes.Except(bestSolutions)) {
+            var maxSimilarity = bestSolutions.Max(x => calculator.CalculateSolutionSimilarity(solScope, x));
+            var qDiff = (GetQuality(solScope, calculator.QualityVariableName) ?? double.NaN)
+                      - (GetQuality(bestSolutions[0], calculator.QualityVariableName) ?? double.NaN);
+            points.Add(new Point2D<double>(Math.Abs(qDiff), 1.0 - maxSimilarity));
+          }
+        } else {
+          for (int i = 0; i < solutionScopes.Count; i++) {
+            for (int j = 0; j < solutionScopes.Count; j++) {
+              if (i == j) continue;
+              var qDiff = (GetQuality(solutionScopes[i], calculator.QualityVariableName) ?? double.NaN)
+                          - (GetQuality(solutionScopes[j], calculator.QualityVariableName) ?? double.NaN);
+              if (double.IsNaN(qDiff)) continue;
+              points.Add(new Point2D<double>(Math.Abs(qDiff), 1.0 - calculator.CalculateSolutionSimilarity(solutionScopes[i], solutionScopes[j])));
+            }
           }
         }
@@ -434,7 +482,10 @@
         splot.VisualProperties.XAxisTitle = "Absolute Fitness Difference";
         splot.VisualProperties.XAxisMinimumFixedValue = 0.0;
+        splot.VisualProperties.XAxisMinimumAuto = false;
         splot.VisualProperties.YAxisTitle = "Solution Distance";
         splot.VisualProperties.YAxisMinimumFixedValue = 0.0;
+        splot.VisualProperties.YAxisMinimumAuto = false;
         splot.VisualProperties.YAxisMaximumFixedValue = 1.0;
+        splot.VisualProperties.YAxisMaximumAuto = false;
         var row = new ScatterPlotDataRow("Fdc", "", points);
         row.VisualProperties.PointSize = 7;
@@ -452,18 +503,20 @@
           solutionsLengthScaleViewHost.Content = dt;
         }
-
         QualityDistributionAnalyzer.UpdateTable(dt, CalculateLengthScale(calculator));
-      } catch { }
+      } catch {
+        solutionsLengthScaleViewHost.Content = null;
+      }
     }
 
     private IEnumerable<double> CalculateLengthScale(ISolutionSimilarityCalculator calculator) {
-      for (int i = 0; i < Content.Problem.Solutions.Count; i++) {
-        for (int j = 0; j < Content.Problem.Solutions.Count; j++) {
+      var solutionScopes = GetSolutionScopes();
+      for (var i = 0; i < solutionScopes.Count; i++) {
+        for (var j = 0; j < solutionScopes.Count; j++) {
           if (i == j) continue;
-          var sim = calculator.CalculateSolutionSimilarity((IScope)Content.Problem.Solutions[i].Solution, (IScope)Content.Problem.Solutions[j].Solution);
+          var sim = calculator.CalculateSolutionSimilarity(solutionScopes[i], solutionScopes[j]);
           if (sim.IsAlmost(0)) continue;
-          var qDiff = Math.Abs(((DoubleValue)((IScope)Content.Problem.Solutions[i].Solution).Variables[calculator.QualityVariableName].Value).Value
-            - ((DoubleValue)((IScope)Content.Problem.Solutions[j].Solution).Variables[calculator.QualityVariableName].Value).Value);
-          yield return qDiff / sim;
+          var qDiff = (GetQuality(solutionScopes[i], calculator.QualityVariableName) ?? double.NaN)
+                    - (GetQuality(solutionScopes[j], calculator.QualityVariableName) ?? double.NaN);
+          if (!double.IsNaN(qDiff)) yield return Math.Abs(qDiff) / sim;
         }
       }
@@ -471,28 +524,51 @@
 
     private void UpdateSolutionNetworkAnalysis(ISolutionSimilarityCalculator calculator) {
+      var series = solutionsNetworkChart.Series["SolutionSeries"];
+      var seedingSeries = solutionsNetworkChart.Series["SeedingSolutionSeries"];
       try {
-        var series = solutionsNetworkChart.Series["SolutionSeries"];
         series.Points.Clear();
-        var dissimilarities = new DoubleMatrix(Content.Problem.Solutions.Count, Content.Problem.Solutions.Count);
-        for (int i = 0; i < Content.Problem.Solutions.Count; i++) {
-          for (int j = 0; j < Content.Problem.Solutions.Count; j++) {
+        seedingSeries.Points.Clear();
+        var solutionScopes = GetSolutionScopes();
+        var dissimilarities = new DoubleMatrix(solutionScopes.Count, solutionScopes.Count);
+        for (var i = 0; i < solutionScopes.Count; i++) {
+          for (var j = 0; j < solutionScopes.Count; j++) {
             if (i == j) continue;
-            dissimilarities[i, j] = 1.0 - calculator.CalculateSolutionSimilarity((IScope)Content.Problem.Solutions[i].Solution, (IScope)Content.Problem.Solutions[j].Solution);
+            dissimilarities[i, j] = 1.0 - calculator.CalculateSolutionSimilarity(solutionScopes[i], solutionScopes[j]);
           }
         }
         var coords = MultidimensionalScaling.KruskalShepard(dissimilarities);
         for (var i = 0; i < coords.Rows; i++) {
-          var quality = ((DoubleValue)((IScope)Content.Problem.Solutions[i].Solution).Variables[calculator.QualityVariableName].Value).Value;
-          series.Points.Add(new DataPoint() {
+          var quality = GetQuality(solutionScopes[i], calculator.QualityVariableName) ?? double.NaN;
+          var dataPoint = new DataPoint() {
             Name = (i + 1).ToString(),
             XValue = coords[i, 0],
-            YValues = new[] { coords[i, 1], quality },
-            Label = i + ": " + quality
-          });
-        }
-      } catch { }
-    }
-    #endregion
-    #endregion
+            YValues = new[] {coords[i, 1], quality},
+            Label = i + ": " + quality,
+            Tag = solutionScopes[i]
+          };
+          if (Content.SolutionSeedingPool.Contains(solutionScopes[i]) && Content.SolutionSeedingPool.ItemChecked(solutionScopes[i]))
+            seedingSeries.Points.Add(dataPoint);
+          else series.Points.Add(dataPoint);
+        }
+      } catch {
+        // problems in calculating the similarity
+        series.Points.Clear();
+        seedingSeries.Points.Clear();
+      }
+    }
+    #endregion
+    #endregion
+
+    private List<IScope> GetSolutionScopes() {
+      return Content.Problem.Solutions.Select(x => x.Solution).OfType<IScope>().ToList();
+    } 
+
+    private double? GetQuality(IScope scope, string qualityName) {
+      IVariable v;
+      if (!scope.Variables.TryGetValue(qualityName, out v)) return null;
+      var dval = v.Value as Data.DoubleValue;
+      if (dval == null) return null;
+      return dval.Value;
+    }
   }
 }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj	(revision 13718)
@@ -83,4 +83,9 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Clients.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Clients.Common-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Clients.OKB-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -146,4 +151,9 @@
       <SpecificVersion>False</SpecificVersion>
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Scripting-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Scripting-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
@@ -173,4 +183,16 @@
     </Compile>
     <Compile Include="Interfaces\IOptimizationExpertSystemUi.cs" />
+    <Compile Include="Menu\0_Config\40_AdministerOkbMenuItem.cs" />
+    <Compile Include="Menu\0_Config\30_DownloadFromOkbMenuItem.cs" />
+    <Compile Include="Menu\0_Config\10_SetCredentialsMenuItem.cs" />
+    <Compile Include="Menu\200_Solving\210_SolverMenuItem.cs" />
+    <Compile Include="Menu\300_Learning\310_AlgorithmInstancesMenuItem.cs" />
+    <Compile Include="Menu\900_Tools\910_NewCSharpScriptMenuItem.cs" />
+    <Compile Include="Menu\900_Tools\930_SaveCSharpScriptMenuItem.cs" />
+    <Compile Include="Menu\900_Tools\920_OpenCSharpScriptMenuItem.cs" />
+    <Compile Include="Menu\MenuItemBase.cs" />
+    <Compile Include="Menu\0_Config\20_SetProblemMenuItem.cs" />
+    <Compile Include="Menu\100_Understanding\120_SolutionsMenuItem.cs" />
+    <Compile Include="Menu\100_Understanding\110_ProblemInstanceMenuItem.cs" />
     <Compile Include="OptimizationExpertSystem.cs">
       <SubType>Form</SubType>
@@ -180,4 +202,16 @@
     </Compile>
     <Compile Include="Plugin.cs" />
+    <Compile Include="UnderstandingProblemInstanceView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="UnderstandingProblemInstanceView.Designer.cs">
+      <DependentUpon>UnderstandingProblemInstanceView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Views\ExpertSystemViewBase.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\ExpertSystemViewBase.Designer.cs">
+      <DependentUpon>ExpertSystemViewBase.cs</DependentUpon>
+    </Compile>
     <None Include="Properties\AssemblyInfo.cs.frame" />
     <Compile Include="Properties\AssemblyInfo.cs" />
@@ -220,4 +254,10 @@
     <EmbeddedResource Include="OptimizationExpertSystem.resx">
       <DependentUpon>OptimizationExpertSystem.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="UnderstandingProblemInstanceView.resx">
+      <DependentUpon>UnderstandingProblemInstanceView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Views\ExpertSystemViewBase.resx">
+      <DependentUpon>ExpertSystemViewBase.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj.user
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj.user	(revision 13713)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/HeuristicLab.OptimizationExpertSystem-3.3.csproj.user	(revision 13718)
@@ -4,5 +4,5 @@
     <StartAction>Program</StartAction>
     <StartProgram>C:\Users\P40311\Work\HL3\trunk\sources\bin\HeuristicLab 3.3.exe</StartProgram>
-    <StartArguments>/start:"Optimizer" /hideStarter</StartArguments>
+    <StartArguments>/start:"Optimization Knowledge Center" /hideStarter</StartArguments>
   </PropertyGroup>
 </Project>
